<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      ref="obTable"
      is-fixed-header
      @select="onSelection"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-large"
      :is-show-pagination="true"
      :is-read-only="true"
    >
      <country
        v-if="selectedData.uuid"
        :selected-data="selectedData"
        :image-data="imageData"
        :api="api"
        @refresh="onRefresh"
        @delete="onDelete"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api                   from '@/api'
import SinglePane            from 'common-components/src/obComponents/obSinglePanels'
import paging                from '@/mixins/dictionaries/paging'
import itemMixin             from '@/mixins/dictionaries/edit-item'
import Country               from './modal/index'
import { getCountryFlag }    from '@/helpers'
import ObModal               from 'common-components/src/obComponents/obModal'
import ObTable               from 'common-components/src/obComponents/obTable'
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__common__countries'


export default {
  name: 'Countries',
  components: {
    ObModal,
    Country,
    SinglePane,
    ObTable
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable () {
      return [
        {
          title: this.dictionaryRu.columns.short_title,
          width: '20%',
          key: 'short_title',
          html: function (data) {
            return `<div class="country-title-block">
              <img width="22" style="box-shadow: 0 0 2px #dbdbdb" src="${getCountryFlag(data.short_symbol_code)}" alt="">
              <span>${data.short_title}</span>
            </div>`
          }
        },
        {
          title: this.dictionaryRu.columns.title,
          width: '10%',
          key: 'title',
        },
        {
          title: this.dictionaryRu.columns.regions,
          key: 'regions',
          allowSorting: false,
          html: function (data)  {
            if(data.regions) {
              let regions = data.regions.reduce((previous, item) => {
                return previous + item.name + ', '
              }, '');
              if(regions.length > 2) {
                regions = regions.slice(0, regions.length - 2);
              }
              return regions;
            }

            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.symbol_code,
          width: 70,
          key: 'symbol_code'
        },
        {
          title: this.dictionaryRu.columns.number_code,
          width: 75,
          key: 'number_code'
        },
        {
          title: this.dictionaryRu.columns.vat,
          width: 70,
          key: 'vat'
        },
        {
          title: this.dictionaryRu.columns.nsp,
          width: 70,
          key: 'nsp'
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          allowSorting: false,
          html: data => {
              return data.is_active
                ? this.dictionaryRu.status.active
                : this.dictionaryRu.status.inactive
          }
        },
      ]
    }
  },
  data() {
    return {
      dataGridRefName: 'CustomsUnions',
      imageData: '',
      api: {
        source: '/oboz2-dictionary-countries-viewer/v1/',
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  methods: {
    async onSelection(data) {
      try {
        let _data = await api.general.getCountry(data.uuid);
        this.imageData = '';
        this.selectedData = _data.data;
        this.$refs.viewItem.open();
        if (this.selectedData.country_image_uuid) {
          let _imageData = await api.general.getCountryImage(this.selectedData.image_uuid);
          this.imageData = _imageData.data.content;
        }
      } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
      }
    },
    async onDelete() {
      const notificationId = `${new Date().getTime()}remove`;

      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Удаление',
          id: notificationId
        });
        await api.general.deleteCountry(this.selectedData.uuid);
        this.$refs.viewItem.close();
        this.$notification({
          type: 'system_notification_success',
          message: 'Удалено'
        })
      }
      catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалено'
        })
      }
      finally {
        this.$notification({event: 'close', id: notificationId})
      }
    }
  }
}
</script>

<style lang="scss">
.country-title-block {
  display: flex;
  justify-content: flex-start;
  align-items: center;

  span {
    padding-left: 10px;
  }
}
</style>
